orte/mca/rml/rml.h File Reference.TH "orte/mca/rml/rml.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/rml/rml.h \- Contains the internal functions and typedefs for the use of the rml. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'include/orte_constants.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'dps/dps_types.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br
\fC#include 'mca/gpr/gpr_types.h'\fP
.br
\fC#include 'mca/rml/rml_types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBORTE_RML_BASE_VERSION_1_0_0\fP"
.br
.RI "\fIMacro for use in components that are of type rml v1.0.0. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef char *(* \fBorte_rml_module_get_uri_fn_t\fP )(void)"
.br
.RI "\fIompi_rml.rml_get_uri() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_set_uri_fn_t\fP )(const char *)"
.br
.RI "\fIompi_rml.rml_set_uri() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_parse_uris_fn_t\fP )(const char *uri, orte_process_name_t *peer, char ***uris)"
.br
.RI "\fIorte_rml.rml_parse_uris() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_ping_fn_t\fP )(const char *uri, const struct timeval *tv)"
.br
.RI "\fIImplementation of orte_rml_ping(). \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_send_fn_t\fP )(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags)"
.br
.RI "\fIorte_rml.rml_send() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_send_buffer_fn_t\fP )(orte_process_name_t *peer, \fBorte_buffer_t\fP *buffer, \fBorte_rml_tag_t\fP tag, int flags)"
.br
.ti -1c
.RI "typedef int(* \fBorte_rml_module_recv_fn_t\fP )(orte_process_name_t *peer, struct iovec *msg, int count, \fBorte_rml_tag_t\fP tag, int flags)"
.br
.RI "\fIorte_rml.rml_recv(). \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_recv_buffer_fn_t\fP )(orte_process_name_t *peer, \fBorte_buffer_t\fP *buf, \fBorte_rml_tag_t\fP tag)"
.br
.RI "\fIorte_rml.rml_recv_buffer() \fP"
.ti -1c
.RI "typedef void(* \fBorte_rml_callback_fn_t\fP )(int status, orte_process_name_t *peer, struct iovec *msg, int count, \fBorte_rml_tag_t\fP tag, void *cbdata)"
.br
.RI "\fICallback function on send/recv completion for iovec messages only, orte_rml.rml_send_nb() and orte_rml.rml_recv_nb() use this. \fP"
.ti -1c
.RI "typedef void(* \fBorte_rml_buffer_callback_fn_t\fP )(int status, orte_process_name_t *peer, \fBorte_buffer_t\fP *buffer, \fBorte_rml_tag_t\fP tag, void *cbdata)"
.br
.RI "\fICallback function on send/recv completion for buffer PACKED message only, orte_rml.rml_send_buffer_nb() and orte_rml.rml_recv_buffer_nb() use this. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_send_nb_fn_t\fP )(orte_process_name_t *peer, struct iovec *msg, int count, \fBorte_rml_tag_t\fP tag, int flags, \fBorte_rml_callback_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIorte_rml.rml_send_nb() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_send_buffer_nb_fn_t\fP )(orte_process_name_t *peer, \fBorte_buffer_t\fP *buffer, \fBorte_rml_tag_t\fP tag, int flags, \fBorte_rml_buffer_callback_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIorte_rml.rml_send_buffer_nb() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_recv_nb_fn_t\fP )(orte_process_name_t *peer, struct iovec *msg, int count, \fBorte_rml_tag_t\fP tag, int flags, \fBorte_rml_callback_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIorte_rml.rml_recv_nb() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_recv_buffer_nb_fn_t\fP )(orte_process_name_t *peer, \fBorte_rml_tag_t\fP tag, int flags, \fBorte_rml_buffer_callback_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIorte_rml.rml_recv_buffer_nb() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_recv_cancel_fn_t\fP )(orte_process_name_t *peer, \fBorte_rml_tag_t\fP tag)"
.br
.RI "\fIorte_rml.rml_recv_cancel() \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_barrier_fn_t\fP )(void)"
.br
.RI "\fIA barrier across all processes w/in the job. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_xcast_fn_t\fP )(orte_process_name_t *root, orte_process_name_t *peers, size_t num_peers, \fBorte_buffer_t\fP *buffer, \fBorte_gpr_trigger_cb_fn_t\fP cbfunc, void *user_tag)"
.br
.RI "\fIxcast function for sending common messages to all processes \fP"
.ti -1c
.RI "typedef void(* \fBorte_rml_exception_callback_t\fP )(const orte_process_name_t *peer, orte_rml_exception_t exception)"
.br
.ti -1c
.RI "typedef int(* \fBorte_rml_module_exception_fn_t\fP )(orte_rml_exception_callback_t cbfunc)"
.br
.RI "\fIRegister a callback function on loss of a connection. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_init_fn_t\fP )(void)"
.br
.RI "\fICalled after the module is selected and the rest of the rte is initialized. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rml_module_fini_fn_t\fP )(void)"
.br
.RI "\fICalled to cleanup the selected modules state. \fP"
.ti -1c
.RI "typedef \fBorte_rml_module_t\fP \fBorte_rml_module_t\fP"
.br
.ti -1c
.RI "typedef \fBorte_rml_module_t\fP *(* \fBorte_rml_component_init_fn_t\fP )(int *priority)"
.br
.RI "\fIRML Component. \fP"
.ti -1c
.RI "typedef \fBorte_rml_component_1_0_0_t\fP \fBorte_rml_component_t\fP"
.br
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBorte_rml_exception_t\fP { \fBORTE_RML_PEER_UNREACH\fP, \fBORTE_RML_PEER_DISCONNECTED\fP }"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC orte_process_name_t \fBorte_rml_name_any\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC orte_process_name_t \fBorte_rml_name_seed\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBorte_rml_module_t\fP \fBorte_rml\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
Contains the internal functions and typedefs for the use of the rml. 


.SH "Define Documentation"
.PP 
.SS "#define ORTE_RML_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* rml v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* rml v1.0 */ \
  'rml', 1, 0, 0
.fi
Macro for use in components that are of type rml v1.0.0. 
.PP
.SH "Typedef Documentation"
.PP 
.SS "typedef void(* \fBorte_rml_buffer_callback_fn_t\fP)(int status, orte_process_name_t *peer, \fBorte_buffer_t\fP *buffer, \fBorte_rml_tag_t\fP tag, void *cbdata)"
.PP
Callback function on send/recv completion for buffer PACKED message only, orte_rml.rml_send_buffer_nb() and orte_rml.rml_recv_buffer_nb() use this. 
.PP
\fBParameters:\fP
.RS 4
\fIstatus\fP (IN) Completion status - equivalent to the return value from blocking send/recv. 
.br
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fIbuffer\fP (IN) For sends, this is a pointer to a prepacked buffer For recvs, OOB creates and returns a buffer 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIcbdata\fP (IN) User data. 
.RE
.PP

.SS "typedef void(* \fBorte_rml_callback_fn_t\fP)(int status, orte_process_name_t *peer, struct iovec *msg, int count, \fBorte_rml_tag_t\fP tag, void *cbdata)"
.PP
Callback function on send/recv completion for iovec messages only, orte_rml.rml_send_nb() and orte_rml.rml_recv_nb() use this. 
.PP
\fBParameters:\fP
.RS 4
\fIstatus\fP (IN) Completion status - equivalent to the return value from blocking send/recv. 
.br
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIcbdata\fP (IN) User data. 
.RE
.PP

.SS "typedef char*(* \fBorte_rml_module_get_uri_fn_t\fP)(void)"
.PP
ompi_rml.rml_get_uri() 
.PP
Note that orte_rml_base_init() must be called to load and select an RML module prior to calling this routine. 
.SS "typedef int(* \fBorte_rml_module_parse_uris_fn_t\fP)(const char *uri, orte_process_name_t *peer, char ***uris)"
.PP
orte_rml.rml_parse_uris() 
.PP
Extract from the contact info the peer process name and uri.
.PP
\fBParameters:\fP
.RS 4
\fIuri\fP (IN) The contact information of the peer process. 
.br
\fIname\fP (OUT) The peer process identifier - MUST BE PREVIOUSLY ALLOCATED. 
.br
\fIuris\fP (OUT) Will return an array of uri strings corresponding to the peers exported protocols.
.RE
.PP
Note the caller may pass NULL for the uris if they only wish to extact the process name. 
.SS "typedef int(* \fBorte_rml_module_ping_fn_t\fP)(const char *uri, const struct timeval *tv)"
.PP
Implementation of orte_rml_ping(). 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fItv\fP (IN) Timeout to wait in connection response. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) or OMPI_SUCCESS 
.RE
.PP

.SS "typedef int(* \fBorte_rml_module_recv_buffer_fn_t\fP)(orte_process_name_t *peer, \fBorte_buffer_t\fP *buf, \fBorte_rml_tag_t\fP tag)"
.PP
orte_rml.rml_recv_buffer() 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or ORTE_RML_NAME_ANY for wildcard receive. 
.br
\fIbuf\fP (OUT) Buffer to receive into. 
.br
\fItag\fP (IN User defined tag for matching send/recv. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received.
.RE
.PP
This version of oob_recv is as above except it does NOT take a iovec list but instead hands back a \fBorte_buffer_t\fP buffer with the message in it. The user is responsible for freeing this buffer with orte_buffer_free() when finished. 
.SS "typedef int(* \fBorte_rml_module_recv_buffer_nb_fn_t\fP)(orte_process_name_t *peer, \fBorte_rml_tag_t\fP tag, int flags, \fBorte_rml_buffer_callback_fn_t\fP cbfunc, void *cbdata)"
.PP
orte_rml.rml_recv_buffer_nb() 
.PP
Non-blocking version of orte_rml.rml_recv_buffer().
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or ORTE_RML_NAME_ANY for wildcard receive. 
.br
\fIbuffer\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) May be MCA_OOB_PEEK to return up to size bytes of msg w/out removing it from the queue, 
.br
\fIcbfunc\fP (IN) Callback function on recv completion. 
.br
\fIcbdata\fP (IN) User data that is passed to callback function. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received.
.RE
.PP
The user supplied callback function is called asynchronously when a message is received that matches the call parameters. 
.SS "typedef int(* \fBorte_rml_module_recv_cancel_fn_t\fP)(orte_process_name_t *peer, \fBorte_rml_tag_t\fP tag)"
.PP
orte_rml.rml_recv_cancel() 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or ORTE_RML_NAME_ANY for wildcard receive. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "typedef int(* \fBorte_rml_module_recv_fn_t\fP)(orte_process_name_t *peer, struct iovec *msg, int count, \fBorte_rml_tag_t\fP tag, int flags)"
.PP
orte_rml.rml_recv(). 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or ORTE_RML_NAME_ANY for wildcard receive. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fItypes\fP (IN) Parallel array to iovecs describing data type of each iovec element. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) May be ORTE_RML_PEEK to return up to the number of bytes provided in the iovec array without removing the message from the queue. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "typedef int(* \fBorte_rml_module_recv_nb_fn_t\fP)(orte_process_name_t *peer, struct iovec *msg, int count, \fBorte_rml_tag_t\fP tag, int flags, \fBorte_rml_callback_fn_t\fP cbfunc, void *cbdata)"
.PP
orte_rml.rml_recv_nb() 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or ORTE_RML_NAME_ANY for wildcard receive. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) May be ORTE_RML_PEEK to return up to size bytes of msg w/out removing it from the queue, 
.br
\fIcbfunc\fP (IN) Callback function on recv completion. 
.br
\fIcbdata\fP (IN) User data that is passed to callback function. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "typedef int(* \fBorte_rml_module_send_buffer_nb_fn_t\fP)(orte_process_name_t *peer, \fBorte_buffer_t\fP *buffer, \fBorte_rml_tag_t\fP tag, int flags, \fBorte_rml_buffer_callback_fn_t\fP cbfunc, void *cbdata)"
.PP
orte_rml.rml_send_buffer_nb() 
.PP
Non-blocking version of orte_rml.rml_send_buffer().
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fIbuffer\fP (IN) Opaque buffer handle. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) Currently unused. 
.br
\fIcbfunc\fP (IN) Callback function on send completion. 
.br
\fIcbdata\fP (IN) User data that is passed to callback function. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error number of bytes actually sent.
.RE
.PP
The user supplied callback function is called when the send completes. Note that the callback may occur before the call to mca_oob_send returns to the caller, if the send completes during the call. 
.SS "typedef int(* \fBorte_rml_module_send_fn_t\fP)(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags)"
.PP
orte_rml.rml_send() 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) Currently unused. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error number of bytes actually sent. 
.RE
.PP

.SS "typedef int(* \fBorte_rml_module_send_nb_fn_t\fP)(orte_process_name_t *peer, struct iovec *msg, int count, \fBorte_rml_tag_t\fP tag, int flags, \fBorte_rml_callback_fn_t\fP cbfunc, void *cbdata)"
.PP
orte_rml.rml_send_nb() 
.PP
Non-blocking version or orte_rml.rml_send().
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) Currently unused. 
.br
\fIcbfunc\fP (IN) Callback function on send completion. 
.br
\fIcbdata\fP (IN) User data that is passed to callback function. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error number of bytes actually sent. 
.RE
.PP

.SS "typedef int(* \fBorte_rml_module_set_uri_fn_t\fP)(const char *)"
.PP
ompi_rml.rml_set_uri() 
.PP
Pre-populate the cache of contact information required by the RTL to reach a given destination. This is required to setup a pointer to initial registry/name server/etc.
.PP
\fBParameters:\fP
.RS 4
\fIuri\fP The contact information of the peer process obtained via a call to orte_ml.rml_get_uri(). 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
